package eu.jonahbauer.raytracing.scene;

import eu.jonahbauer.raytracing.math.BoundingBox;
import eu.jonahbauer.raytracing.math.Range;
import eu.jonahbauer.raytracing.math.Ray;
import org.jetbrains.annotations.NotNull;

import java.util.Optional;

public interface Hittable {

    /**
     * {@return the value <code>t</code> such that <code>ray.at(t)</code> is the intersection of this shaped closest to
     * the ray origin, or <code>Double.NaN</code> if the ray does not intersect this shape}
     * @param ray a ray
     */
    @NotNull Optional<HitResult> hit(@NotNull Ray ray, @NotNull Range range);

    default @NotNull Optional<BoundingBox> getBoundingBox() {
        return Optional.empty();
    }
}
